#include <xgpio_l.h>
#include <net/xilsock.h>
#include <xparameters.h>
#include "web.h"
#include "http.h"
#include "peripheral.h"

struct web_conn_ent web_conns[MAX_WEB_CONNS];
unsigned char file_not_found[] = "HTTP/1.1 404 Not Found\r\nContent-type: text/html\n\rConnection: close\r\n\r\nFile Not Found!";
unsigned char http_hdr[] = "HTTP/1.1 200 OK\n\rContent-type: text/html\n\rConnection: close\n\r\r\n";
unsigned char *bg_tab[] = {
    "#63B1B1","#FFFFCC","#808040","#FFCC99","#CC6600", "#99FF99"};
unsigned char *index1 = "<html><head></head><body bgcolor=\"";
unsigned char d2 = 0xf;
int stop_webserver=0;
extern int count;

/*
 * Web Connections Management
 */
unsigned char iswebinit = 0;

// Character string for the index.html file.
unsigned char *index_html = "\"><center><b><font size=+3>PowerPC Web Server on Xilinx PMP Board</font></b></center><br><font face=\"Garamond\">A Simple Web Server running on <b>PowerPC</b>.Check out the following demos.</font><p><b><font face=\"Garamond\">4-bit LED Display:</font></b><p><font face=\"Garamond\">Type in the LED number you would like to turn on, press enter or click summit to make it happen.<p>Input \"x\" or \"X\" to stop the webserver.</font><br><form action=\"pl\" method=\"get\"><b><font face=\"Garamond\">Hex Value</font></b><input type=\"text\" size=\"1\" name=\"textbox\"><p><input type=\"submit\" value=\"Submit\"><br></form><font face=\"Garamond\"></font><p><b><font face=\"Garamond\">Changing Colors :</font></b><p><font face=\"Garamond\">See the background color of the page change everytime when reloaded.<p><a href=\"index2.html\">Yet Another File on PowerPC</a></font><p><b><font face=\"Garamond\">DIP Switches:</font></b><font face=\"Garamond\"></font><p><font face=\"Garamond\">Set Dip Switches 0 1 2 3  and see it displayed as binary on reload</font><b><font face=\"Garamond\"></font></b><p><b><font face=\"Garamond\">DIP Value: ";

// Character string for the index2.html file.
unsigned char *index2_html ="\"><center><b><font size=+3>PowerPC Web Server on Xilinx XUP Board</font></b></center><br><font face=\"Garamond\">index2.html on <b>PowerPC</b>.<p><a href=\"index.html\">Back</a></font></body></html>";

unsigned char *stop_html = "\"><center><b><font size=+3>Web Server Stopped!</font></b></center></body></html>";

unsigned char dip[7];

/*
 * Process a Web Connection
 */
int do_proc_req(int n) {
    char fname[15] = {0};
    int  num;
    char *tok;
    
    // Obtain a pointer to the location in the "send frame" where the
    // data is supposed to start. The pointer needs to
    // skip over all of the header information.
    unsigned char *sndptr = (unsigned char*)(sendbuf +
                                             LINK_HDR_LEN +
                                             IP_HDR_LEN*4 +
                                             (TCP_HDR_LEN*4));
    int i1len, bglen;

    unsigned int http_hdr_len = strlen(http_hdr);
    
    // Obtain a pointer to the receive buffer.
    // Global array of sockets (xilsock.h)
    unsigned char *receive_buffer = xilsock_sockets[web_conns[n].s].recvbuf.buf;
    
    if (!receive_buffer)
        return 0; 
    
    /*
     * Ack for Data Sent
     */
    if (xilsock_status_flag & XILSOCK_TCP_ACK) {
        xil_printf("XILSOCK_TCP_ACK\r\n");
        xilsock_close(web_conns[n].s);
        free_web_conn(n);
        if(stop_webserver)
            return -1;
        else
            return 0;
    }
    /*
     * GET Request
     */
    else if (xilsock_status_flag & XILSOCK_TCP_DATA) {
        int i;
        
        xil_printf("XILSOCK_TCP_DATA\r\n");
        /*
         * Read DIP switches
         */
        dip[0] = getDIP(0) + 48;
        dip[1] = getDIP(1) + 48;
        dip[2] = getDIP(2) + 48;
        dip[0] = getDIP(3) + 48;
        dip[1] = getDIP(4) + 48;
        dip[2] = getDIP(5) + 48;
        dip[3] = getDIP(6) + 48;
        
        i1len = strlen(index1);
        bglen = strlen(bg_tab[count]);
        
        // Find the first space in the receive buffer
        tok = strtok(receive_buffer, " ");
        // Find the scond space in the receive buffer
        tok = strtok('\0', " ");
        // Increment the pointer.
        tok ++;
        
        xil_printf("Processing Request...\n\r");

        // See if "pl" action method is requested.
        if (tok[0] == 'p' && tok[1] == 'l') {

            xil_printf("pl action method\r\n");
			d2 = tok[11];

            if (d2 >= '0' && d2 <= '3' )
	            d2 = tok[11] - 48 ;
            else if ( d2 == 'x' || d2 == 'X' ){
                stop_webserver = 1;
                strcpy(fname,"stop.html");
            }
			turnLED(-1, 0);
            turnLED(d2, 1);
        }
        else {
            int i;
			xil_printf("File name given\r\n");
            // Instead, a filename is given as a parameter
            strcpy(fname,tok);
			for(i=0; i<15; i++)
				xil_printf("%c",fname[i]);
			xil_printf("\r\n");
        }
        
        // part of stdlib. Fills the 'sendbuf' buffer with all zeros
        memset(sendbuf, 0, LINK_FRAME_LEN);
        
        /**
         * Fill HTTP header and send requested file
         */
        // Set the HTTP 1.1 header
        memcpy(sndptr, http_hdr, http_hdr_len);
        if (!(*fname))
            // if no filename is specified, use "index.html"
            strcpy(fname, "index.html");

        xil_printf("Send on socket: %d\r\n", web_conns[n].s);
        
        // Open the file that was sent
        if ( !strcmp(fname,"index.html")) {
            int diplen = 4;
            memcpy((sndptr+http_hdr_len+i1len+bglen),index_html,strlen(index_html));
            strcat((sndptr+http_hdr_len+i1len+bglen), dip);
            
            memcpy((sndptr+http_hdr_len+i1len), bg_tab[count], bglen);
            memcpy((sndptr+http_hdr_len), index1, i1len);
            num = xilsock_send(web_conns[n].s, sendbuf, strlen(index_html)+http_hdr_len+i1len+bglen+diplen);
            memset(sendbuf, 0, 1514);
            xil_printf("done..\n\r");
        }else if( !strcmp(fname, "index2.html") ){
            memcpy((sndptr+http_hdr_len+i1len+bglen),index2_html,strlen(index2_html));
            memcpy((sndptr+http_hdr_len+i1len), bg_tab[count], bglen);
            memcpy((sndptr+http_hdr_len), index1, i1len);
            num = xilsock_send(web_conns[n].s, sendbuf, strlen(index2_html)+http_hdr_len+i1len+bglen);
            memset(sendbuf, 0, 1514);
            xil_printf("done..\n\r");
        }else if( !strcmp(fname, "stop.html") ){
            memcpy((sndptr+http_hdr_len+i1len+bglen),stop_html,strlen(stop_html));
            memcpy((sndptr+http_hdr_len+i1len), bg_tab[count], bglen);
            memcpy((sndptr+http_hdr_len), index1, i1len);
            num = xilsock_send(web_conns[n].s, sendbuf, strlen(stop_html)+http_hdr_len+i1len+bglen);
            memset(sendbuf, 0, 1514);
            xil_printf("done..\n\r");
        }
        else {
            xil_printf("file not found \n\r");       
            // send http file not found message
            memcpy(sndptr, file_not_found, 24);
            memcpy(&sndptr[24], "File Not Found", strlen("File Not Found"));
            // send file not found message to socket
            n = xilsock_send(web_conns[n].s, sendbuf, strlen(sndptr));
        }
        count++;

        return 0;
    }
    
}

/*
 * Initialise all web conns.
 */
void init_web_conns() {
    int i;

    for (i = 0; i < MAX_WEB_CONNS; i++) {
        web_conns[i].s =-1;
        web_conns[i].file_name = NULL;
        web_conns[i].bytes_rem = 0;
        web_conns[i].state = WEB_CONN_FREE;
    }
    iswebinit = 1;
}

/*
 * Add a web connection
 */
int add_web_conn(int s) {
    int i;
    
    
    //If WEB is not initialized, init it
    if (!iswebinit)
        init_web_conns();
    
    //Looking for a free WEB connection
    for ( i = 0; i < MAX_WEB_CONNS; i++) {
        if (web_conns[i].state == WEB_CONN_FREE)
            break;
    }
    
    if ( i < MAX_WEB_CONNS) {
        //If there is one free
        web_conns[i].s = s;
        web_conns[i].state = WEB_GET;

        xil_printf("Add Web Conn, socket: %d\n\r", web_conns[i].s);

        return i;
    }else{
        xil_printf("no free conns \n\r");
        return -1;
    }
}

/*
 * Free a web connection
 */
void free_web_conn(int s) {
    web_conns[s].s = -1;
    web_conns[s].state = WEB_CONN_FREE;
}

/*
 * Process all web connections
 */
int do_proc_conns() {
   int i, result;
   
   for (i = 0; i < MAX_WEB_CONNS; i++){
       result = do_proc_req(i);
       // reset buf ptrs of sockets
       xilsock_sockets[web_conns[i].s].recvbuf.buf = NULL;
       xilsock_sockets[web_conns[i].s].recvbuf.size = 0;
   }
   return result;
}
